<template>
    <section>
        <div v-if="curso" class="address-box">
            <div class="card border m-b-30">
                <div class="card-header">
                    <h5 class="mb-0">{{ curso.title }}</h5>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-lg-3 text-center mb-3">
                            <img
                                :src="curso.feature_image"
                                alt=""
                                class="img-fluid"
                            />
                        </div>
                        <div class="col-lg-6">
                            <span class="badge badge-light font-16">{{
                                curso.categorias ? curso.categorias.name : ""
                            }}</span>
                            <div class="form-group">
                                <div class="input-group">
                                    <input
                                        type="search"
                                        class="form-control"
                                        placeholder="Coupon Code"
                                        aria-label="Search"
                                        aria-describedby="button-addonTags"
                                        v-model="cupon"
                                    />
                                    <div class="input-group-append">
                                        <button
                                            class="input-group-text"
                                            id="button-addonTags"
                                            @click.prevent="aplicarCupon()"
                                        >
                                            Apply
                                        </button>
                                    </div>
                                </div>
                            </div>
                            <p class="text-primary font-26 f-w-7 my-3">
                                <sup v-if="curso.price_sale" class="font-16"
                                    >$</sup
                                >{{ curso.price_sale ? curso.price_sale : "" }}
                                <span
                                    :class="
                                        curso.price_sale
                                            ? 'text-danger descount'
                                            : ''
                                    "
                                    ><sup class="font-16">$</sup
                                    >{{ curso.price }}</span
                                >
                            </p>
                            <p class="mb-0">
                                Para revisar el curso solicitado click
                                <a
                                    target="_blank"
                                    :href="'/curso/' + curso.slug_id"
                                    >aquí</a
                                >
                            </p>
                        </div>
                        <div class="col-lg-3"></div>
                    </div>
                </div>
                <div class="card-footer ">
                    <div class="row">
                        <div class="col-lg-7">
                            ¿Desea continuar con el pedido?
                        </div>
                        <div class="col-lg-4 text-center">
                            <div class="button-list">
                                <button
                                    v-on:click.prevent="pedido"
                                    type="button"
                                    class="btn btn-round btn-success-rgba mb-1"
                                >
                                    <i class="ti-check"></i>
                                </button>
                                <button
                                    @click="cancel"
                                    type="button"
                                    class="btn btn-round btn-danger-rgba mb-1"
                                >
                                    <i class="ti-close"></i>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div v-if="order" class="address-box">
            <div class="card border m-b-30">
                <div class="card-header">
                    <h5 class="mb-0">Pedido # {{ order.id }}</h5>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-lg-3 mb-3">
                            <img
                                src="/assets/images/small_logo.svg"
                                alt=""
                                class="img-fluid"
                            />
                        </div>
                        <div class="col-lg-6">
                            <span class="font-16">
                                Para ver la planilla generada presiona
                                <a
                                    :href="
                                        '/dashboard/compras/plantilla/' +
                                            order.id
                                    "
                                    target="_blank"
                                    >aquí</a
                                >
                            </span>
                            <p class="text-primary font-26 f-w-7 my-3">
                                <sup class="font-16">$</sup>{{ order.price }}
                            </p>
                        </div>
                        <div class="col-lg-3"></div>
                    </div>
                </div>
                <div class="card-footer ">
                    <div class="row">
                        <div class="col-lg-7">
                            ¿Desea continuar con el pedido?
                        </div>
                        <div class="col-lg-4 text-center">
                            <button
                                @click="process"
                                type="submit"
                                class="btn btn-round btn-success-rgba mb-1"
                            >
                                <i class="ti-check"></i>
                            </button>
                            <button
                                @click="cancel"
                                type="button"
                                class="btn btn-round btn-danger-rgba mb-1"
                            >
                                <i class="ti-close"></i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div v-if="!order && !curso" class="address-box">
            <div class="card border m-b-30">
                <div class="card-header">
                    <h5 class="mb-0"></h5>
                </div>
                <div class="card-body">
                    <div class="row">
                        <div class="col-lg-3 mb-3">
                            <img
                                src="/assets/images/small_logo.svg"
                                alt=""
                                class="img-fluid"
                            />
                        </div>
                        <div class="col-lg-6">
                            <span class="font-16">
                                Aún no ha seleccionado una planilla de
                                inscripcion para procesar el pago
                            </span>
                        </div>
                        <div class="col-lg-3"></div>
                    </div>
                </div>
                <div class="card-footer ">
                    <div class="row">
                        <div class="col-lg-7">
                            ¿Desea ver los pedidos pendientes por procesar?
                        </div>
                        <div class="col-lg-4 text-center">
                            <button
                                @click.prevent="dashboard"
                                type="submit"
                                class="btn btn-round btn-success-rgba mb-1"
                            >
                                <i class="ti-check"></i>
                            </button>
                            <button
                                @click="cancel"
                                type="button"
                                class="btn btn-round btn-danger-rgba mb-1"
                            >
                                <i class="ti-close"></i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</template>

<script>
export default {
    props: ["paso", "auths"],
    mounted() {
        this.get();
    },
    data() {
        return {
            curso: "",
            order: "",
            step: this.paso,
            user: this.auths,
            cupon: "",
            error: "",
            success: "",
            cupon_active: ""
        };
    },
    methods: {
        get() {
            let ins = sessionStorage.getItem("inscripcion");
            let order = sessionStorage.getItem("order");
            if (ins) {
                this.curso = JSON.parse(ins);
            }
            if (order) {
                this.order = JSON.parse(order);
            }
        },
        next() {
            this.$emit("nextStep", 2);
        },
        aplicarCupon() {
            this.error = "";
            this.success = "";
            this.get();
            if (this.cupon && !this.cupon_active) {
                axios.get("/api/config/promo-code/" + this.cupon).then(res => {
                    console.log(res.data);
                    if (res.data.error) {
                        this.error = res.data.message;
                    } else {
                        $("#button-addonTags").attr("disabled", true);
                        this.cupon_active = res.data;
                        if (this.cupon_active.percent_desc) {
                            this.desc_perc =
                                (this.total * this.cupon_active.percent_desc) /
                                100;
                            this.total = this.total - this.desc_perc;
                            this.success =
                                "Se ha aplicado satisfactoriamente el codigo de promoción " +
                                this.code +
                                "obteniendo un descuento de " +
                                this.cupon_active.percent_desc +
                                "% por el valor todal de la inscripción.";
                        } else {
                            this.desc_val = this.cupon_active.value_desc;
                            this.total = this.total - this.desc_val;
                            this.success =
                                "Se ha aplicado satisfactoriamente el codigo de promoción " +
                                this.code +
                                "obteniendo un descuento de " +
                                this.cupon_active.percent_val +
                                "$ por el valor todal de la inscripción.";
                        }
                    }
                });
            } else {
                this.error = "Debe agregar un cupon valido.";
            }
        },
        process() {
            let o = sessionStorage.getItem("order");
            sessionStorage.setItem("order", "");
            sessionStorage.setItem("pay",o)
            sessionStorage.setItem("active", "order");
            this.next();
        },
        pedido() {
            let order;
            if (this.curso.price_sale) {
                order = {
                    total: this.curso.price_sale,
                    user: this.user,
                    cars: [this.curso]
                };
            } else {
                order = {
                    total: this.curso.price,
                    user: this.user,
                    cars: [this.curso]
                };
            }

            axios.post("/api/accounting/orders", order).then(res => {
                sessionStorage.setItem("inscripcion", "");
                sessionStorage.setItem("active", "inscripcion");
                this.next();
            });
        },
        dashboard() {
            location.href = "/dashboard";
        },
        cancel() {
            location.href = "/";
        }
    }
};
</script>
